
const char sdPin = 13;
const char Pin13OutLow  = 0b11011111;
const char Pin13OutHigh = 0b00100000;
boolean	xflag = false;

void setup() {
	Serial.begin(1200);
	pinMode(sdPin, OUTPUT);
	xflag = false;
}

void loop() {
	char	rdt;
	char	ct;
	char	dt;
	char	bufcnt;
	int		i;

	PORTB &= Pin13OutLow;

	bufcnt = Serial.available();
	if (bufcnt > 0) {
		if (bufcnt >= 0x80 && xflag == false) {
			Serial.write(0x13);	// Xoff
			xflag = true;
		} else if (bufcnt <= 0x10 && xflag == true) {
			Serial.write(0x11);	// Xon
			xflag = false;
		}
		rdt = Serial.read();

		switch (rdt) {
			case 0xff:
				while (Serial.available() < 2) {
					;
				}
				ct = Serial.read();
				dt = Serial.read();
				SendByte(ct,dt);
				break;
			default:
				SendByte(0x00,rdt);
				break;
		}
		delay(5);
	}

}

void SendByte(char ct,char dt) {
	char	i;
	char	cttmp,dttmp;
	char	pt;

	cttmp = ct;
	dttmp = dt;

	OutHeader();

	pt = 0x00;
	for (i = 0;i < 3;i ++) {
		if ( (ct & 0x01) != 0x00 ) {
			OutHigh();
			pt = pt ^ 0x01;
		} else {
			OutLow();
		}
		ct = ct >> 1;
	}

	for (i = 0;i < 8;i ++) {
		if ( (dt & 0x01) != 0x00 ) {
			OutHigh();
			pt = pt ^ 0x01;
		} else {
			OutLow();
		}
		dt = dt >> 1;
	}

	if ( pt != 0x00 ) {
		OutHigh();
	} else {
		OutLow();
	}

	ct = cttmp;
	dt = dttmp;

	for (i = 0;i < 3;i ++) {
		if ( (ct & 0x01) != 0x00 ) {
			OutLow();
		} else {
			OutHigh();
		}
		ct = ct >> 1;
	}

	for (i = 0;i < 8;i ++) {
		if ( (dt & 0x01) != 0x00 ) {
			OutLow();
		} else {
			OutHigh();
		}
		dt = dt >> 1;
	}

	if ( pt != 0x00 ) {
		OutLow();
	} else {
		OutHigh();
	}

}

void OutHeader() {
	char	i;

	for (i = 0;i < 96;i ++) {
		PORTB |= Pin13OutHigh;
		delayMicroseconds(13);
		PORTB &= Pin13OutLow;
		delayMicroseconds(13);
	}
	delayMicroseconds(26*19);
	for (i = 0;i < 16;i ++) {
		PORTB |= Pin13OutHigh;
		delayMicroseconds(13);
		PORTB &= Pin13OutLow;
		delayMicroseconds(13);
	}
}

void OutHigh() {
	char	i;

	PORTB &= Pin13OutLow;
	delayMicroseconds(26*38);
	for (i = 0;i < 16;i ++) {
		PORTB |= Pin13OutHigh;
		delayMicroseconds(13);
		PORTB &= Pin13OutLow;
		delayMicroseconds(13);
	}
}

void OutLow() {
	char	i;

	PORTB &= Pin13OutLow;
	delayMicroseconds(26*11);
	for (i = 0;i < 16;i ++) {
		PORTB |= Pin13OutHigh;
		delayMicroseconds(13);
		PORTB &= Pin13OutLow;
		delayMicroseconds(13);
	}
}


